// R_REM.H : Remote f. Radio
// G. TAMM, DF9ZO 2007
//--------------------
#ifndef _R_REM_H_
#define _R_REM_H_
//--------------------
#ifndef _R_VAR_H_
  #include "R_VAR.H"
#endif
#ifndef _R_DLG_H_
  #include "R_DLG.H"
#endif
#ifndef _R_LIB_H_
  #include "R_LIB.H"
#endif
#ifndef _R_COM_H_
  #include "R_COM.H"
#endif
//--------------------
#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemWin+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RemWin : public CFrameWnd
{
	DECLARE_DYNCREATE(RemWin)
public:
    RemWin(CFrameWnd* parent,CString& file);

    CString LineBuf;
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RemWin)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

protected:
    RemWin();  
	virtual ~RemWin();

    CFrameWnd* winparent;
    char       finame[Fl];                      
    //Scrollbars-------------
    int ScrX,ScrXmax,ScrY,ScrPaStep;
    int SchrH,SchrB;     

    void OnReturn();
    void UpdateScrBars();    
    void OnHome();
	void OnEnd();
	void OnLineDo();
	void OnLineUp();
	void OnPageDo();
	void OnPageUp();
    void OnLineRi();
	void OnLineLe();
	void OnPageRi();
	void OnPageLe();
    // Generated message map functions
	//{{AFX_MSG(RemWin)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnPaint();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemDisp++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RemDisp : public CFrameWnd
{
	DECLARE_DYNCREATE(RemDisp)
public:
	RemDisp(); 
	virtual ~RemDisp();

    void UpdateFreqDisp(void);
    void UpdateStatusDisp(int line1,int line2,int line3);
    void ChFreq(unsigned int step,int up);
    unsigned int CalcDispStep(int mx);
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RemDisp)
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL
protected:
    CBrush Brush,*oldbrush;
    CFont  Nfont,Ffont,*oldfont;

    int Hn,Bn,Hf,Bf;//Schrift: Hoehe normal/freq, Breite: normal/freq
    int SHIFT_DO,CTRL_DO;
    char DispStr1[150],DispStr2[150],DispStr3[150];
	// Generated message map functions
	//{{AFX_MSG(RemDisp)
    afx_msg LRESULT MsgUpdateFreq(WPARAM wParam,LPARAM lParam);
    afx_msg LRESULT MsgUpdateStatus(WPARAM wParam,LPARAM lParam);

	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()    
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemExtDlg++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RemExtDlg : public CDialog
{
public:
	RemExtDlg(CWnd* pParent = NULL);   // standard constructor

    int GetCOMAnswer(int retexp);

// Dialog Data
	//{{AFX_DATA(RemExtDlg)
	enum { IDD = IDD_REMEXTDLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RemExtDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL
protected:
    HACCEL      m_hAccel;
    CScrollBar  *pSB;

	// Generated message map functions
	//{{AFX_MSG(RemExtDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnPAMP();
	afx_msg void OnANT();
	afx_msg void OnATT();
	afx_msg void OnAGC();
	afx_msg void OnANF();
	afx_msg void OnNB();
	afx_msg void OnNR();
    afx_msg void OnDUP();
    afx_msg void OnRTTY();
    afx_msg void OnAskAll();
	afx_msg void OnNeutral();
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()    
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//RemDlg+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RemDlg : public CDialog
{
public:
	RemDlg(CWnd* pParent = NULL);   // standard constructor

    int GetCOMAnswer(int retexp);
    //return-Werte: s. R_Com.cpp

    void SetCOMTimer();
    void KillCOMTimer();
// Dialog Data
	//{{AFX_DATA(RemDlg)
	enum { IDD = IDD_REMDLG };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(RemDlg)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void PostNcDestroy();
	//}}AFX_VIRTUAL

protected:
    HACCEL      m_hAccel;

    afx_msg LRESULT OnMemSel(WPARAM wParam,LPARAM lParam);
	// Generated message map functions
	//{{AFX_MSG(RemDlg)
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnASK_SandSQL();
	afx_msg void OnEXTENDED();
	afx_msg void OnLOG();
	afx_msg void OnMEM();
	afx_msg void OnSET_F();
	afx_msg void OnSET_LAST();
	afx_msg void OnSET_FOFFSET();
	afx_msg void OnSET_MODE();
	afx_msg void OnHOWTO();
	afx_msg void OnASK_FandM();
	afx_msg void OnSET_FSTEP_HW();
	afx_msg void OnSET_FSTEP_SW();
    afx_msg void OnSET_VFO_AB();
    afx_msg void OnSET_VFOMEM();    
    afx_msg void OnTUNE();
    afx_msg void OnTimer(UINT nIDEvent);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()     
};
//Globals++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#define WM_REMWIN_ITEMSELECTION (WM_USER + 13)
extern RemDlg*    remdlg;
extern RemExtDlg* remextdlg;
extern RemDisp*   remdisp;
extern RemWin*    remwin;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#endif // _R_REM_H_
